/*
  copyright(c) 2003 - 2004 Miki Akiyoshi
  
  This file is part of Miki Review.
  
  Miki Review is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Review is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Review; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.review ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.beans.* ;
import java.io.* ;
import java.util.prefs.Preferences ;

public class mkApplet extends JApplet 
{
    private static Preferences userPrefs;

    public static final String STYLESHEET_NAME = "stylesheet_name" ;
    public static final String DEF_STYLESHEET_NAME = "style01.xsl" ;

    public static final String INDEX_STYLESHEET_NAME 
	= "index_stylesheet_name" ;
    public static final String DEF_INDEX_STYLESHEET_NAME = "idxstyle01.xsl" ;

    public static final String FILEPREFIX_NAME = "fileprefix_name" ;
    public static final String DEF_FILEPREFIX_NAME = "p" ;

    public static final String FILE_NAME = "file_name" ;
    public static final String DEF_FILE_NAME = "myreview.ser" ;

    public static final String DIR_NAME = "dir_name" ;
    public static final String DEF_DIR_NAME = "." ;

    public static final String LAST_FILE_NAME = "last_file_name" ;

    public static final String HOME_URL = "home_url" ;
    public static final String DEF_HOME_URL = 
	"http://enjoy.pial.jp/~getup/" ;

    public static final String HOME_TITLE = "home_title" ;
    public static final String DEF_HOME_TITLE = "My Review" ;

    public static final String INSTALL_URL = "install_url" ;
    public static final String DEF_INSTALL_URL = 
	"http://enjoy.pial.jp/~getup/archives/" ;

    public static final String INDEX_NAME = "index_name" ;
    public static final String DEF_INDEX_NAME = "p9999" ;

    public static final String RSS_NAME = "rss_name" ;
    public static final String DEF_RSS_NAME = "myreview.xml" ;


    public mkApplet()
    {
	super() ;
    }
    static final String tl =
	"Miki Review Ver 2.1 copyright(c) 2003 - 2004 Miki Akiyoshi" ;


    static private JFrame _frame ;

    public static JFrame getFrame()
    {
	return _frame ;
    }


    public static void main(String[] args) 
    {
        _frame = new JFrame(tl);

        _frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    System.exit(0);
		}
	    });
	
        mkApplet applet = new mkApplet() ;

        userPrefs = 
	    Preferences.userNodeForPackage(mkApplet.class) ;

	applet.setSize(920, 700) ;

	_frame.getContentPane().add("Center", applet) ;

        _frame.pack();
	_frame.setSize(920, 700) ;

	applet.start() ;
	applet.init() ;

        _frame.setVisible(true);
    }

    private mkLeftWidget left ;

    public mkLeftWidget getLeftWidget()
    {
	return left ;
    }

    private mkRightWidget right ;


    public mkRightWidget getRightWidget()
    {
	return right ;
    }

    private mkDialog dialog ;
    static private mkErrDialog errdialog ;

    public static void showErrDialog(Exception ex)
    {
	errdialog.show(ex) ;
    }

    public mkDialog getDialog()
    {
	return dialog ;
    }

    public Preferences getPreferences()
    {
	return userPrefs ;
    }

    public void init()
    {

	int gno = 0 ;
	try {
	    gno = mkLookAndFeelAction.init(this) ;
	} catch(Exception ex){}

	getContentPane().setLayout(null) ;

	JMenuBar bar = new JMenuBar() ;
	JMenu menu  = null ;
	JMenuItem mi  = null ;

	menu = new JMenu("t@C(F)") ;
	menu.setMnemonic(KeyEvent.VK_F);

	mi = new JMenuItem("VK쐬(N)", KeyEvent.VK_N) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_N, ActionEvent.CTRL_MASK));
	mi.addActionListener(new mkClearAction(this)) ;
	menu.add(mi) ;

	mi = new JMenuItem("t@CJ(O)", KeyEvent.VK_O) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_O, ActionEvent.CTRL_MASK));
	mi.addActionListener(new mkFileLoadAction(this)) ;
	menu.add(mi) ;

	mi = new JMenuItem("t@Cɕۑ(S)", KeyEvent.VK_S) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_S, ActionEvent.CTRL_MASK));
	mi.addActionListener(new mkFileSaveNoDialogAction(this)) ;
	menu.add(mi) ;

	mi = new JMenuItem("Oĕۑ(A)", KeyEvent.VK_A) ;
	mi.addActionListener(new mkFileSaveAction(this)) ;
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("I(X)", KeyEvent.VK_X) ;
	mi.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		System.exit(0) ;
	    }}) ;
	
	menu.add(mi) ;
	bar.add(menu) ;

	menu = new JMenu("ҏW(E)") ;
	menu.setMnemonic(KeyEvent.VK_E);

	mi = new JMenuItem("(F)", KeyEvent.VK_F) ;
	mi.addActionListener(new mkSearchAction(this)) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_F, ActionEvent.CTRL_MASK));
	menu.add(mi) ;

	menu.addSeparator();

	mi = new JMenuItem("HTMLɏo",KeyEvent.VK_H) ;
	mi.setAccelerator(KeyStroke.getKeyStroke(
			 KeyEvent.VK_H, ActionEvent.CTRL_MASK));
	mi.addActionListener(new mkToHTMLAction(this)) ;
	menu.add(mi) ;

	mi = new JMenuItem("RSSo",KeyEvent.VK_R) ;
	mi.addActionListener(new mkCreateRSSAction(this)) ;
	menu.add(mi) ;

	mi = new JMenuItem("XMLɏo",KeyEvent.VK_X) ;
	mi.addActionListener(new mkToXMLAction(this, false)) ;
	menu.add(mi) ;

	mi = new JMenuItem("X^CV[gtXMLɏo(Y)",
			   KeyEvent.VK_Y) ;
	mi.addActionListener(new mkToXMLAction(this, true)) ;
	menu.add(mi) ;


	menu.addSeparator();

	mi = new JMenuItem("ݒ(C)",KeyEvent.VK_C) ;
	mi.addActionListener(new mkControlDialogAction(this)) ;
	menu.add(mi) ;
	bar.add(menu) ;

	menu = new JMenu("\(V)") ;
	menu.setMnemonic(KeyEvent.VK_V);

	mi = new JMenuItem("̑傫(F)",KeyEvent.VK_F) ;
	menu.add(mi) ;

	JMenu submenu = new JMenu("LOOKFEEL") ;
	menu.setMnemonic(KeyEvent.VK_L);

	ButtonGroup group = new ButtonGroup();


	JRadioButtonMenuItem[] rb = new JRadioButtonMenuItem[4] ;
	rb[0] = new JRadioButtonMenuItem("Windows") ;
	rb[0].addActionListener(new mkLookAndFeelAction(this, 0)) ;
	rb[0].setMnemonic(KeyEvent.VK_W);
	group.add(rb[0]) ;
	submenu.add(rb[0]) ;

	rb[1] = new JRadioButtonMenuItem("Linux") ;
	rb[1].setMnemonic(KeyEvent.VK_L);
	rb[1].addActionListener(new mkLookAndFeelAction(this, 1)) ;
	group.add(rb[1]) ;
	submenu.add(rb[1]) ;

	rb[2] = new JRadioButtonMenuItem("Java") ;
	rb[2].addActionListener(new mkLookAndFeelAction(this, 2)) ;
	rb[2].setMnemonic(KeyEvent.VK_J);
	group.add(rb[2]) ;
	submenu.add(rb[2]) ;

	rb[3] = new JRadioButtonMenuItem("Unix") ;
	rb[3].addActionListener(new mkLookAndFeelAction(this, 3)) ;
	rb[3].setMnemonic(KeyEvent.VK_U);
	group.add(rb[3]) ;
	submenu.add(rb[3]) ;

	rb[gno].setSelected(true) ;

	menu.add(submenu) ;

	mi = new JMenuItem("̑傫(F)",KeyEvent.VK_F) ;
	bar.add(menu) ;


	menu = new JMenu("c[(T)") ;
	menu.setMnemonic(KeyEvent.VK_T);

	mi = new JMenuItem("z[ɃAbv(U)",KeyEvent.VK_U) ;
	menu.add(mi) ;

	mi = new JMenuItem("o̓vr[(P)", KeyEvent.VK_P) ;
	menu.add(mi) ;

	bar.add(menu) ;

	setJMenuBar(bar) ;

	left = new mkLeftWidget() ;

	getContentPane().add(left.create(this)) ;

	// ---------------------------------------------

	Class c = getClass() ;
	ImageIcon ic = new ImageIcon(c.getResource("images/icon03.gif")) ;
	JButton btn = new JButton("V炵r[", ic) ;
	btn.setBounds(605, 10, 300, 35) ;	
	btn.addActionListener(new mkNewAction(this)) ;
	getContentPane().add(btn) ;	
	
	right = new mkRightWidget() ;

	getContentPane().add(right.create(this)) ;

	dialog = new mkDialog(this, _frame, "ݒ") ;

	errdialog = new mkErrDialog(this, new Frame(), "G[bZ[W") ;
    }
}

