/*
  copyright(c) 2003 - 2004 Miki Akiyoshi
  
  This file is part of Miki Review.
  
  Miki Review is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Review is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Review; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.review ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.io.* ;
import java.util.* ;
import org.w3c.dom.* ;
import javax.xml.parsers.* ;
import javax.xml.transform.* ;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import java.util.prefs.Preferences ;

public class mkCard implements Serializable , Cloneable
{
    static final long serialVersionUID = -68896251587049139L;

    public mkCard()
    {
	super() ;
    }

    public mkCard(String  title, 
		  String  name,
		  String  image,
		  String  affiliate,
		  String  date,
		  String  body)
    {
	super() ;
	
	setTitle(title) ;
	setName(name) ;
	setImage(image) ;
	setAffiliate(affiliate) ;
	setDate(date) ;
	setBody(body) ;
    }
    private  String  _title, _name, _image, _affiliate, _date ;
    private  String  _body ;
    transient private String _fileName ;
    transient private mkLabel _lb ;
    private boolean _del ;
    private mkCard  _old ;

    public void setLabel(mkLabel arg)
    {
	_lb = arg ;
    }

    public mkLabel getLabel()
    {
	return _lb ;
    }

    public String getFileName()
    {
	return _fileName ;
    }

    private  Vector  _rel = new Vector() ;

    public Vector getRelation()
    {
	return _rel ;
    }

    public void addRelation(mkCard arg)
    {
	if(_rel.size() > 8){
	    return ;
	}
	_rel.addElement(arg) ;
    }

    public void removeRelation(mkCard arg)
    {
	_rel.removeElement(arg) ;
    }

    public String getTitle()
    {
	return _title ;
    }


    public String setTitle(String arg)
    {
	return _title = arg ;
    }

    public String getName()
    {
	return _name ;
    }



    public String setName(String arg)
    {
	return _name = arg ;
    }

    public String getImage()
    {
	return _image ;
    }


    public String setImage(String arg)
    {
	return _image = arg ;
    }


    public String getAffiliate()
    {
	return _affiliate ;
    }


    public String setAffiliate(String arg)
    {
	return _affiliate = arg ;
    }



    public String setDate(String arg)
    {
	return _date = arg ;
    }




    public String getDate()
    {
	return _date ;
    }

    public String setBody(String arg)
    {
	return _body = arg ;
    }


    public String getBody()
    {
	return _body ;
    }


    public Vector setRelation(Vector arg)
    {
	return (_rel = (Vector )arg.clone()) ;
    }


    public mkCard set(mkCard arg)
    {
	_title = arg._title ;
	_name = arg._name ;
	_image = arg._image ;
	_affiliate = arg._affiliate ;
	_date = arg._date ;
	_body = arg._body ;

	_rel = arg._rel ;

	_lb.setText(_title) ;

	return this ;
    }

    public String createFileName(int arg, String front, String ext)
    {
	String num = Integer.toString(arg) ;

	_fileName =  front +
	    "0000".substring(num.length(), 4)+num+ext ;

	return getFileName() ;
    }


    public void toXML(Preferences pref, String sheet)
    {
	if(_del){
	    return ;
	}

	try {
	    Document doc = createDocument(".xml", sheet) ;

	    TransformerFactory t = TransformerFactory.newInstance() ;
	    Transformer tf = t.newTransformer() ;
	    tf.setOutputProperty(OutputKeys.ENCODING,"Shift_JIS");
	    tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, "review.dtd") ;

	    String dir = pref.get(mkApplet.DIR_NAME,
				  mkApplet.DEF_DIR_NAME) ;
	    
	    tf.transform(new DOMSource(doc), 
			 new StreamResult(new File(dir+getFileName()))) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }


    static public final String pid = "-//W3C//DTD XHTML 1.0 Strict//EN" ;
    static public final String sid = 
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" ;

    public void toHTML(Preferences pref)
    {
	if(_del){
	    return ;
	}

	try {

	    Document doc = createDocument(".html", null) ;

	    TransformerFactory t = TransformerFactory.newInstance() ;

	    String sname = pref.get(mkApplet.STYLESHEET_NAME,
				    mkApplet.DEF_STYLESHEET_NAME) ;
	    Source src = new StreamSource(new File(sname)) ;
	    Transformer tf = t.newTransformer(src) ;
	    tf.setOutputProperty(OutputKeys.ENCODING,"Shift_JIS");
	    tf.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC, pid) ;
	    tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, sid) ;
	    tf.setOutputProperty(OutputKeys.METHOD, "html") ;

	    String dir = pref.get(mkApplet.DIR_NAME,
				  mkApplet.DEF_DIR_NAME) ;

	    tf.transform(new DOMSource(doc), 
			 new StreamResult(new File(dir+getFileName()))) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }


    public Document
	createDocument(String ext, String sheet) throws Exception
    {
	DocumentBuilderFactory dbf = 
	    DocumentBuilderFactory.newInstance();
	dbf.setValidating(true) ;
	DocumentBuilder db  = dbf.newDocumentBuilder();
	
	DOMImplementation dimpl = db.getDOMImplementation() ;
	DocumentType dtype = 
	    dimpl.createDocumentType("review", null, "review.dtd") ;
	// System.out.println(dtype.getName()) ;
	// System.out.println(dtype.getSystemId()) ;
	Document document = dimpl.createDocument(null,"review", dtype) ;
	
	ProcessingInstruction pi = null ;
	if(sheet != null){
	    pi = 
		document.createProcessingInstruction("xml-stylesheet",
						     "type=\"text/xsl\"" 
						     + " href=\""
						     + sheet+"\"") ;
	}
	
	Element top = null ;
	Element elm = null ;
	Text tx = null ;
	top = document.getDocumentElement() ;
	if(pi != null){
	    document.insertBefore(pi, top) ;
	}
	
	elm = document.createElement("title") ;
	tx = document.createTextNode(getTitle()) ; 
	elm.appendChild(tx) ;
	top.appendChild(elm) ;
	
	if(getName() != null){
	    elm = document.createElement("author") ;	    
	    tx = document.createTextNode(getName()) ;
	    elm.appendChild(tx) ;
	    top.appendChild(elm) ;
	}
	
	String img = getImage() ;
	if(img != null){
	    if(getImage().equals("default")){
		img = getFileName().replaceAll(ext, ".jpg") ;
	    }
	    elm = document.createElement("photo") ;	    
	    elm.setAttribute("src", img) ;
	    top.appendChild(elm) ;
	}
	
	createParagraph(document, top, getBody()) ;
	
	elm = document.createElement("date") ;	    
	tx = document.createTextNode(getDate()) ;
	elm.appendChild(tx) ;
	top.appendChild(elm) ;
	
	if(getAffiliate() != null){
	    elm = document.createElement("affiliate") ;	    
	    tx = document.createTextNode(getAffiliate()) ;
	    elm.appendChild(tx) ;
	    top.appendChild(elm) ;
	}
	
	Enumeration en = _rel.elements() ;
	while(en.hasMoreElements()){
	    mkCard cd = ((mkCard )en.nextElement()) ;
	    elm = document.createElement("relation") ;	    
	    elm.setAttribute("url", cd.getFileName()) ;
	    tx = document.createTextNode(cd.getTitle()) ;
	    elm.appendChild(tx) ;
	    top.appendChild(elm) ;
	}
	
	return document ;
    }


    public void createParagraph(Document document, 
				Element top,
				String src) throws Exception 
    {
	BufferedReader br = new BufferedReader(new StringReader(src)) ;

	int onflag = 0 ;
	String line = null ;
	StringBuffer para = null ;
	Element elm = null ;

	// SpXy[X
	byte[] zspace = {(byte )0x81, 0x40} ;
	String zsp = new String(zspace) ;

	while((line = br.readLine()) != null){
	    line = line.replaceAll(zsp,"\t").trim() ;
	    if(line.length() != 0){
		if(onflag == 0){
		    onflag = 1 ;
		    elm = document.createElement("paragraph") ;	    
		    para = new StringBuffer() ;
		}
		para.append(line) ;
	    } else {
		if(onflag ==1){
		    Text tx = document.createTextNode(para.toString()) ;
		    elm.appendChild(tx) ;
		    top.appendChild(elm) ;
		    onflag = 0 ;
		} 
	    }
	}
	if(onflag == 1){
	    Text tx = document.createTextNode(para.toString()) ;
	    elm.appendChild(tx) ;
	    top.appendChild(elm) ;
	    onflag = 0 ;
	} 
    }

    public void delete()
    {
	_del = true ;
    }


    public void alive()
    {
	_del = false ;
    }

    public boolean deletep()
    {
	return _del ;
    }


    public mkCard getOld()
    {
	return _old ;
    }

    public mkCard newVersion()
    {
	_old = (mkCard )clone() ;

	return this ;
    }


    public Object clone() 
    {
	try {
	    mkCard other = (mkCard )super.clone();
	    other._old = null ;
	    return other;
	} catch (CloneNotSupportedException e) {
	    // this shouldn't happen, since we are Cloneable
	    throw new InternalError();
	}
    }
}


