/*
  copyright(c) 2003 - 2004  Miki Akiyoshi
  
  This file is part of Miki Review.
  
  Miki Review is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Review is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Review; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.review ;

import java.io.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.prefs.Preferences ;

public class mkFileNameAction implements ActionListener,
					 FilenameFilter
{
    private mkApplet  _app ;
    private JTextField _txt ;

    private int _mode ;
    private String _filter ;

    public mkFileNameAction(int mode, mkApplet arg, JTextField txt,
			    String filter)
    {
	_app = arg ;
	_txt = txt ;
	_mode = mode ;
	_filter = filter ;
    }

    public void actionPerformed(ActionEvent e)
    {
	mkLeftWidget lw = _app.getLeftWidget() ;
	mkRightWidget rw = _app.getRightWidget() ;


	FileDialog fd = new FileDialog(_app.getFrame(), 
				       "t@CJ") ;
	
	if(_filter != null){
	    fd.setFilenameFilter(this) ;
	    fd.setFile("*"+_filter) ;
	}
	fd.setMode(_mode) ;
	
	fd.show() ;
	
	String dir = fd.getDirectory() ;
	
	String fname = fd.getFile() ;
	
	if(dir != null && fname != null){
	    String path = dir+fname ;
	    _txt.setText(path) ;
	    /*
	    Preferences pref = _app.getPreferences() ;
	    pref.put(mkApplet.STYLESHEET_NAME, path) ;
	    */
	}
    }

    public boolean accept(File dir, String name)
    {
	return name.endsWith(_filter) ;
    }
}

