/*
  copyright(c) 2003 - 2004  Miki Akiyoshi
  
  This file is part of Miki Review.
  
  Miki Review is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Review is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Review; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.review ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.io.* ;
import java.util.* ;
import java.awt.dnd.* ;
import java.awt.datatransfer.* ;

public class mkLabel extends JLabel implements Serializable , 
					       DragGestureListener ,
					       Transferable
{

    public static DataFlavor compFlavor = 
	new DataFlavor("application/x-java-object", "Object") ;

    private mkCard _card ;

    public mkCard getCard()
    {
	return _card ;
    }

    public mkLabel(mkCard arg, Icon ic)
    {
	super(arg.getTitle(), ic, JLabel.LEFT) ;

	_card = arg ;

	DragSource ds = new DragSource() ;

        ds.createDefaultDragGestureRecognizer(
                this, DnDConstants.ACTION_COPY_OR_MOVE, 
		this) ;
    }


    public DataFlavor[] getTransferDataFlavors()
    {
	DataFlavor[] f = new DataFlavor[1];
        f[0] = compFlavor ;
        return f;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor)
    {
	if (flavor.getHumanPresentableName().equals("Object")) {
            return true;
	} else {
	    return false;
	}
    }
    
    public Object getTransferData(DataFlavor flavor)
    {
	return this ;
    }

    public void dragGestureRecognized(DragGestureEvent e) 
    {
	e.startDrag(DragSource.DefaultMoveDrop, this) ;
    }
}
