/*
  copyright(c) 2003 - 2004  Miki Akiyoshi
  
  This file is part of Miki Review.
  
  Miki Review is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Miki Review is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with Miki Review; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/

package jp.dip.ikim.review ;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.io.* ;
import java.util.* ;
import java.awt.dnd.* ;
import java.util.prefs.Preferences ;
import org.w3c.dom.* ;
import javax.xml.parsers.* ;
import javax.xml.transform.* ;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import java.text.* ;

public class mkRightWidget implements Serializable
{
    mkApplet _app ;


    public mkRightWidget()
    {
	super() ;

	_list = new Vector() ;

	c_y = 5 ;
	count = 0 ;
    }

    private JScrollPane _spane ;
    private JPanel _panel ;
    private Vector _list ;

    public void clearAll()
    {
	_list = new Vector() ;

	c_y = 5 ;
	count = 0 ;

	_panel.removeAll() ;

	_spane.repaint() ;
    }


    public JScrollPane getScrollPane()
    {
	return _spane ;
    }


    public JPanel getPanel()
    {
	return _panel ;
    }


    public JScrollPane create(mkApplet app)
    {
	_app = app ;

	JLabel lb = null ;
	_panel = new JPanel(null) ;
	_spane = new JScrollPane(_panel) ;
	_spane.setBounds(605,45, 300,550) ;	
        _spane.setVerticalScrollBarPolicy(
			  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS) ;
        _spane.setPreferredSize(new Dimension(200, 400));
	_spane.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createCompoundBorder(
                        BorderFactory.createTitledBorder("^Cgꗗ"),
                        BorderFactory.createEmptyBorder(5,5,5,5)),
                _spane.getBorder()));	
	// _spane.setBackground(Color.pink) ;
	return getScrollPane() ;
    }

    private int c_y  ;
    private int count ;

    public int getCount()
    {
	return count ;
    }

    public static final int ITEM_HEIGHT = 30 ;
    public static final int ITEM_MARGIN = 2 ;
    public static final int MARGIN = 10 ;


    public int createLabel(mkCard arg)
    {
	Class c = getClass() ;
	ImageIcon ic = new ImageIcon(c.getResource("images/icon04.gif")) ;
	mkLabel lb = new mkLabel(arg, ic) ;
	arg.setLabel(lb) ;

	Dimension dim = _panel.getSize() ;
	if(dim.height < c_y+30){
	    _panel.setPreferredSize(new Dimension(dim.width, c_y+30+MARGIN)) ;
	    _panel.revalidate() ;
	}
	lb.setBounds(5, c_y, 195, 30) ;
	++count ;
	c_y += ITEM_HEIGHT + ITEM_MARGIN ;
	
	_panel.add(lb) ;

	lb.addMouseListener(new mkClickAction(arg, _app)) ;

	_spane.repaint() ;

	return getCount() ;
    }

    public void removeItem(mkCard arg)
    {
	if(arg != null){
	    _list.removeElement(arg) ;
	}
    }


    public int addItem(mkCard arg)
    {
        if((arg != null) && (! _list.contains(arg))){
	    _list.addElement(arg) ;
	    return createLabel(arg) ;
	}

	return getCount() ;
    }

    public void saveFile(String arg) throws Exception
    {
	FileOutputStream fos = new FileOutputStream(arg) ;
	ObjectOutputStream os = 
	    new ObjectOutputStream(new BufferedOutputStream(fos)) ;

	os.writeObject(_list) ;

	os.close() ;
    }

    public void loadFile(String arg) throws Exception
    {
	FileInputStream fis = new FileInputStream(arg) ;
	ObjectInputStream is = 
	    new ObjectInputStream(new BufferedInputStream(fis)) ;

	_list = (Vector )is.readObject() ;

	Enumeration en = _list.elements() ;

	while(en.hasMoreElements()){
	    createLabel((mkCard )en.nextElement()) ;
	}

	_spane.repaint() ;
	
	is.close() ;
    }

    public void toXML(boolean sheet)
    {
	Preferences pref = _app.getPreferences() ;

	Enumeration en = _list.elements() ;

	Document doc = prepareList(pref) ;
	Element elm = startList(doc, pref, sheet) ;

	int i = 0; 
	while(en.hasMoreElements()){
	    mkCard card = (mkCard )en.nextElement() ;
	    card.createFileName(++i, 
				pref.get(mkApplet.FILEPREFIX_NAME,
					 mkApplet.DEF_FILEPREFIX_NAME),
				".xml") ;
	    addItemToList(pref, doc, elm, card) ;
	}

	endList(pref, doc) ;

	en = _list.elements() ;

	String file = null ;
	if(sheet){
	    String path = pref.get(mkApplet.STYLESHEET_NAME,
				   mkApplet.DEF_STYLESHEET_NAME) ;
	    file = new File(path).getName() ;
	}
	while(en.hasMoreElements()){
	    mkCard card = (mkCard )en.nextElement() ;
	    card.toXML(_app.getPreferences(), file) ;
	}
    }


    public void toHTML()
    {
	Preferences pref = _app.getPreferences() ;

	Enumeration en = _list.elements() ;

	Document doc = prepareList(pref) ;
	Element elm = startList(doc, pref, false) ;

	int i = 0; 
	while(en.hasMoreElements()){
	    mkCard card = (mkCard )en.nextElement() ;
	    card.createFileName(++i, 
				pref.get(mkApplet.FILEPREFIX_NAME,
					 mkApplet.DEF_FILEPREFIX_NAME),
				".html") ;
	    if(! card.deletep()){
		addItemToList(pref, doc, elm, card) ;
	    }
	}

	endListAndTransform(pref, doc) ;

	en = _list.elements() ;

	while(en.hasMoreElements()){
	    mkCard card = (mkCard )en.nextElement() ;
	    card.toHTML(_app.getPreferences()) ;
	}
    }

    static final String def_ns = "http://purl.org/rss/1.0/" ;
    
    static final String rdf_ns = 
	"http://www.w3.org/1999/02/22-rdf-syntax-ns#" ;

    static final String dc_ns = "http://purl.org/dc/elements/1.1/" ;



    public void createFileName(String ext, Preferences pref)
    {
	Enumeration en = _list.elements() ;

	int i = 0; 
	while(en.hasMoreElements()){
	    mkCard card = (mkCard )en.nextElement() ;
	    card.createFileName(++i, 
				pref.get(mkApplet.FILEPREFIX_NAME,
					 mkApplet.DEF_FILEPREFIX_NAME),
				ext) ;
	}
    }
	    

    public void createRSS()
    {
	Preferences pref = _app.getPreferences() ;

	try {

	    createFileName(".html", pref) ;
	    
	    DocumentBuilderFactory dbf = 
		DocumentBuilderFactory.newInstance() ;
	    dbf.setNamespaceAware(true) ;
	    DocumentBuilder db =  dbf.newDocumentBuilder() ;
	    Document dm = db.newDocument() ;

	    Text tx = 
		dm.createTextNode("sample.xsl") ;
	    
	    ProcessingInstruction pi = 
		dm.createProcessingInstruction("xml-stylesheet" ,
					       "href=\""+
					       tx+"\" type=\"text/xsl\"") ;
	    dm.appendChild(pi) ;
	    
	    Element top = 
		dm.createElementNS(rdf_ns, "rdf:RDF") ;
	     
	    top.setAttribute("xmlns", def_ns) ;
	    
	    top.setAttributeNS(rdf_ns, "xmlns:rdf", rdf_ns) ;
	    
	    top.setAttributeNS(dc_ns, "xmlns:dc", dc_ns) ;
	    
	    top.setAttribute("xmlns:lang", "ja") ;
	    
	    dm.appendChild(top) ;
	    
	    Element ch = dm.createElementNS(null, "channel") ;
	    top.appendChild(ch) ;
	    
	    Element el = dm.createElementNS(null, "title") ;
	    tx = 
		dm.createTextNode(pref.get(mkApplet.HOME_TITLE,
					   mkApplet.DEF_HOME_TITLE)) ;
	    el.appendChild(tx) ;
	    ch.appendChild(el) ;
	    
	    el = dm.createElementNS(null, "link") ;
	    tx = 
		dm.createTextNode(pref.get(mkApplet.HOME_URL,
					   mkApplet.DEF_HOME_URL));
	    el.appendChild(tx) ;
	    ch.appendChild(el) ;
	    
	    el = dm.createElementNS(null, "description") ;
	    tx = 
		dm.createTextNode(pref.get(mkApplet.HOME_TITLE,
					   mkApplet.DEF_HOME_TITLE)) ;
	    el.appendChild(tx) ;
	    ch.appendChild(el) ;
	    
	    el = dm.createElementNS(dc_ns, "dc:date") ;
	    Date day = new Date() ;
	    
	    
	    SimpleDateFormat sdf = 
		new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ") ;
	    
	    StringBuffer sb = 
		sdf.format(new Date(),
			   new StringBuffer(),
			   new FieldPosition(NumberFormat.INTEGER_FIELD));
	    
	    tx = dm.createTextNode(sb.toString()) ;
	    el.appendChild(tx) ;
	    ch.appendChild(el) ;
	    
	    el = dm.createElementNS(null, "items") ;
	    ch.appendChild(el) ;
	    
	    Element seq = dm.createElementNS(rdf_ns, "rdf:Seq") ;
	    el.appendChild(seq) ;
	    
	    int size = _list.size() ;
	    // System.out.println("size="+size) ;
	    
	    for(int i = (size>15 ? 14 : size-1); i >= 0; i--){
		mkCard card = (mkCard )_list.elementAt(i) ;
		
		if(card.deletep()){
		    continue ;
		}

		el = dm.createElementNS(rdf_ns, "rdf:li") ;
		el.setAttributeNS(rdf_ns,
				  "rdf:resource",
				  pref.get(mkApplet.INSTALL_URL,
					   mkApplet.DEF_INSTALL_URL)
				  + card.getFileName()) ;
		seq.appendChild(el) ;
	    }
	    
	    int cc = size-1 ;
	    for(int i = (size>15 ? 14 : size-1); i >= 0; i--, cc--){
		mkCard card = (mkCard )_list.elementAt(cc) ;
		
		if(card.deletep()){
		    continue ;
		}

		Element it = dm.createElement("item") ;
		String url = 
		    pref.get(mkApplet.INSTALL_URL,
			     mkApplet.DEF_INSTALL_URL)
		    + card.getFileName() ;
		
		it.setAttributeNS(rdf_ns, "rdf:about", url) ;
		
		el = dm.createElement("title") ;
		tx = dm.createTextNode(card.getTitle()) ;
		el.appendChild(tx) ;
		it.appendChild(el) ;
		
		el = dm.createElement("link") ;
		tx = dm.createTextNode(url) ;
		el.appendChild(tx) ;
		it.appendChild(el) ;
		
		el = dm.createElementNS(dc_ns, "dc:date") ;		 
		tx = dm.createTextNode(card.getDate()) ;
		el.appendChild(tx) ;
		it.appendChild(el) ;
		
		el = dm.createElement("description") ;
		tx = 
		    dm.createTextNode(card.getBody().substring(0,30).trim()
				      + " .....") ;
		el.appendChild(tx) ;
		it.appendChild(el) ;
		
		top.appendChild(it) ;
	    }
	    
	    Transformer tf = 
		TransformerFactory.newInstance().newTransformer() ;
	    tf.setOutputProperty(OutputKeys.ENCODING, "UTF-8") ;
	    
	    String path = 
		pref.get(mkApplet.DIR_NAME, mkApplet.DEF_DIR_NAME) + 
		pref.get(mkApplet.RSS_NAME, mkApplet.DEF_RSS_NAME) ;
	    tf.transform(new DOMSource(dm),
			 new StreamResult(path)) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }	


    public Document prepareList(Preferences pref)
    {
	try {
	    DocumentBuilderFactory dbf = 
		DocumentBuilderFactory.newInstance() ;
	    dbf.setValidating(true) ;
	    DocumentBuilder db =  dbf.newDocumentBuilder() ;
	    DOMImplementation dimpl = db.getDOMImplementation() ;
	    DocumentType dtype = 
		dimpl.createDocumentType("reviewlist", 
					 null, "reviewlist.dtd") ;
	    return dimpl.createDocument(null,"reviewlist", dtype) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	    return null ;
	}
    }
	
    public Element startList(Document doc,
			     Preferences pref, boolean sheet)
    {
	try {
	    ProcessingInstruction pi = null ;
	    if(sheet){
		String path = pref.get(mkApplet.INDEX_STYLESHEET_NAME,
				       mkApplet.DEF_INDEX_STYLESHEET_NAME) ;
		String file = new File(path).getName() ;

		pi = 
		    doc.createProcessingInstruction("xml-stylesheet",
						    "type=\"text/xsl\"" 
						    + " href=\""
						    + file+"\"") ;
	    }
	    
	    Element top = null ;
	    Element elm = null ;
	    Text tx = null ;
	    top = doc.getDocumentElement() ;
	    if(pi != null){
		doc.insertBefore(pi, top) ;
	    }
	    return top ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	    return null ;
	}
    }


    public void addItemToList(Preferences pref, Document doc, 
			      Element top, mkCard card) 
    {
	Element elm = null ;
	Text tx = null ;
	
	try {
	    elm = doc.createElement("item") ;
	    top.appendChild(elm) ;

	    top = elm ;

	    elm = doc.createElement("title") ;
	    tx = doc.createTextNode(card.getTitle()) ; 

	    elm.setAttribute("url", card.getFileName()) ;
	    elm.appendChild(tx) ;
	    top.appendChild(elm) ;
	    
	    if(card.getName() != null){
		elm = doc.createElement("author") ;	    
		tx = doc.createTextNode(card.getName()) ;
		elm.appendChild(tx) ;
		top.appendChild(elm) ;
	    }
	
	    elm = doc.createElement("date") ;	    
	    tx = doc.createTextNode(card.getDate()) ;
	    elm.appendChild(tx) ;
	    top.appendChild(elm) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }

    public void endList(Preferences pref, Document doc)
    {
	try {
	    Transformer tf = 
		TransformerFactory.newInstance().newTransformer() ;
	    tf.setOutputProperty(OutputKeys.ENCODING, "Shift_JIS") ;
	    tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, "reviewlist.dtd") ;
	    
	    String path = 
		pref.get(mkApplet.DIR_NAME, mkApplet.DEF_DIR_NAME) + 
		pref.get(mkApplet.INDEX_NAME, mkApplet.DEF_INDEX_NAME) +
		".xml" ;
	    tf.transform(new DOMSource(doc),
			 new StreamResult(path)) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }	

    public void endListAndTransform(Preferences pref, Document doc)
    {
	try {
	    TransformerFactory t = TransformerFactory.newInstance() ;

	    String sname = pref.get(mkApplet.INDEX_STYLESHEET_NAME,
				    mkApplet.DEF_INDEX_STYLESHEET_NAME) ;
	    Source src = new StreamSource(new File(sname)) ;
	    Transformer tf = t.newTransformer(src) ;
	    tf.setOutputProperty(OutputKeys.ENCODING,"Shift_JIS");
	    tf.setOutputProperty(OutputKeys.DOCTYPE_PUBLIC, mkCard.pid) ;
	    tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM, mkCard.sid) ;
	    tf.setOutputProperty(OutputKeys.METHOD, "html") ;

	    String dir = pref.get(mkApplet.DIR_NAME,
				  mkApplet.DEF_DIR_NAME) ;

	    String fname = pref.get(mkApplet.INDEX_NAME,
				    mkApplet.DEF_INDEX_NAME) + ".html" ;
				    
	    tf.transform(new DOMSource(doc), 
			 new StreamResult(new File(dir+fname))) ;
	} catch(Exception ex){
	    mkApplet.showErrDialog(ex) ;
	}
    }

    public Vector searchStringFromList(String arg)
    {
	Vector retv = new Vector() ;

	Enumeration en = _list.elements() ;

	while(en.hasMoreElements()){
	    mkCard card = (mkCard )en.nextElement() ;
	    int idx = card.getTitle().indexOf(arg) ;
	    if(idx != -1){
		retv.addElement(new mkSearchResult(card, 
						   arg,
						   mkSearchResult.TITLE, 
						   idx)) ;
		continue ;
	    }
	    idx = card.getName().indexOf(arg) ;
	    if(idx != -1){
		retv.addElement(new mkSearchResult(card, 
						   arg,
						   mkSearchResult.NAME, 
						   idx)) ;
		continue ;
	    }


	    idx = card.getDate().indexOf(arg) ;
	    if(idx != -1){
		retv.addElement(new mkSearchResult(card, 
						   arg,
						   mkSearchResult.DATE, 
						   idx)) ;
		continue ;
	    }

	    idx = card.getBody().indexOf(arg) ;
	    if(idx != -1){
		retv.addElement(new mkSearchResult(card, 
						   arg,
						   mkSearchResult.BODY, 
						   idx)) ;
		continue ;
	    }
	}

	return retv ;
    }
}
							    


